#!/usr/bin/env python
"""
SYNOPSIS:
    ./htmlfilter [paranoia-level] < bad-html.htm > good-html.htm
    paranoia level = 0 -> High paranoia
                   = 1 -> Low paranoia

DESCRIPTION:
    This is a HTML sanitizer. Given HTML text as input, the program will
    cleanse it of any tags that could possibly cause security
    issues. These include embedded flash object, or java applets, or
    java script, etc.

    This is an exercise for HW1 (CS261):
    http://www.eecs.berkeley.edu/~daw/teaching/cs261-f09/hws/hw1.html

AUTHOR:
    XXX

LICENSE:
    This script is in the public domain, free from copyrights or
    restrictions.
"""

ALLOWED_TAGS = ['a', 'abbr', 'acronym', 'address', 'area',
                'b', 'base', 'basefont', 'bdo', 'big', 'blockquote',
                'body', 'br', 'button', 'caption', 'center', 'cite',
                'code', 'col', 'colgroup', 'dd', 'del', 'dir', 'div',
                'dfn', 'dl', 'dt', 'em', 'fieldset', 'font', 'form',
                'h1', 'h2', 'h3', 'h4', 'h5', 'h6',
                'head', 'hr', 'html', 'i', 'img', 'input',
                'ins', 'isindex', 'kbd', 'label', 'legend', 'li',
                'link', 'map', 'menu', 'meta', 'noframes', 'noscript',
                'ol', 'optgroup', 'option', 'p', 'param',
                'pre', 'q', 's', 'samp', 'select', 'small',
                'span', 'strike', 'strong', 'style', 'sub', 'sup',
                'table', 'tbody', 'td', 'textarea', 'tfoot', 'th',
                'thead', 'title', 'tr', 'tt', 'u', 'ul', 'var', 'xmp']
                
EVIL_TAGS_LIST = ['object',
                  'script',
                  'iframe',
                  'frame',
                  'frameset',
                  'applet']

TAG_REPL_DICT =  {'noframes' : 'p',
                  'noscript' : 'p'}

EVIL_ATTRS = ['onload', 'onunload', 'onblur', 'onchange', 'onfocus',
              'onreset', 'onselect', 'onsubmit', 'onkeydown',
              'onkeypress', 'onkeyup', 'onabort', 'onclick',
              'ondblclick', 'onmousedown', 'onmousemove', 'onmouseout',
              'onmouseover', 'onmouseup']

EVIL_ATTR_VAL_PREFIX = ['javascript'] # browsers don't seem to interpret vbscript:
